/***
*data.c - disked data
*
*Copyright (c) 1994-1995, Gregg Jennings.  All wrongs reserved.
*   P O Box 200, Falmouth, MA 02541-0200
*
*Purpose:
*   Place for major text.
*
*Notice:
*   This progam may be freely used and distributed.  Any distrubution
*   with modifications must retain the above copyright statement and
*   modifications noted.
*   No pulp-publication, in whole or in part, permitted without
*   permission (magazines or books).
******************************************************************************/

/*
   Versions:

   1.2   16-Sep-1994    CUG reference
   1.1   04-Sep-1994    '\' and '^F' descriptions
*/



/* NO globals referenced here */

/* ALL definitions here ARE global */


#define NULL 0

char *com_line_text[] = {
"\nDISKED [-|+hfrst] [/x{file}] [/r{file}] [/f{text}] [/s{B|F|n|file}] [/5] [d:]\n",
"options: - off  + on",
"\t  h home",
"\t  f files",
"\t  r restore",
"\t  s save",
"\t  t translate\n",
"\t  /x{file} initialization file override",
"\t  /r{file} save file override",
"\t  /f{text} find text",
"\t  /s{B|F|n|file} set to BOOT, FAT, sector n, or file",
"\t  /5 screen is 50 lines",
"\t  d: drive",
NULL
};

char *signon_text[] = {
"\n                                  DISKED",
"                              The DISK EDitor\n",
"          This program is still being improved and feedback from",
"     users is extremely essential!\n",
"          Anyone sending me their name and address is entitled for",
"     a postscript printed manual, free future versions and support.\n",
"          The source code for this program is available through the",
"     CUG as volume #406B; see the file SOURCE.TXT for more information.\n",
"          NOTE: It is okay to give this program away.\n",
"          ALSO: Please read the documentation that should come with",
"     this program for important copyleft information.  If the",
"     documentation is missing, please write me for a copy.\n",
"          AND: This version LETS YOU WRITE to the disk.  NO WARRANTY",
"     is made, expressed, or implied.\n",
"          THANK YOU      Gregg Jennings",
"                         P O Box 200",
"                         Falmouth  MA  02540-0200\n",
   NULL
};


char *command_text1[] = {
" Commands:\n",
"        Drive:                  Movement:                 File Buffer: ",
"   'ld' log disk d          'n' next sector           'a' append sector ",
"   '^L' re-log drive        'b' back sector           'u' unappend sector ",
"   'fs' find string s       'h' next head             'A' append cluster  ",
"    BS  display stats       'N' next cluster          'U' unappend cluster",
"                            'B' back cluster        '^An' append n bytes ",
"        Sector Buffer:     '^N' next track          '^Un' unappend n bytes ",
"    'c' change from n      '^B' back track           'gn' get n sectors ",
"   '^C' change dir     'sn,n,n' set position        '^Gn' get n sectors & move ",
"    'k' kill changes       'Sn' set to cluster n     'dn' display from n ",
"    '>' store             '^Sn' set to sector n      'vn' view from n ",
"    '<' retrieve            'r' range                 'e' empty ",
"    'w' write               'H' home                 '^E' empty no ask ",
" SPACE  display top         'E' end                  'ps' put to file s ",
"    CR  display rest       F10s goto file s         '^Ps' put no options",
"   'tn' tag sector         ^END end of file          'is' insert file s ",
"  '1-9' goto tag          ^HOME start of file       '^Is' insert no options",
"                         ^RIGHT next file cluster     'I' insert current file",
"    'q' quit              ^LEFT back file cluster    'Cn' change from n ",
"    '?' more help          '^Q' go back              'Fs' find string s  ",
   NULL
};

char *command_text2[] = {
" Extra Commands:\n",
"    'z' set params          'Z' display params        ',' toggle input radix",
"    'Y' restore state      '^Y' save state            '!' shell to DOS",
"    'x' view ini file       '\\' find, ignore case    '^F' find, ignore case",
"    'm' map file            'M' map free space   'Pn,n,s' put sectors to s",
"    F1  directory           F2  list files            F3  number of files",
"    F4s change directory    F5  re-read sector        F6  append w/strip",
"    F7  append w/convert    F8  append w/mask         F9  append w/options",
"   SF1  display partial    SF2  display full         SF3  display ascii",
"   SF4  display directory  SF6  DOS help             '^T' track file",
"SRIGHT  next free clus.  SLEFT  back free clus.  ",
   NULL
};

char *dir_help[] = {
   "\n\n\tDirectory Entry:\n",
   "\t00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F",
   "\t|     filename         |  ext   |at| reserved |",
   "\n\t10 11 12 13 14 15 16 17 18 19 1A 1B 1C 1D 1E 1F",
   "\t|    reserved    |time |date |start|file size |\n",
   "\tnote: DRDOS uses the reserved area for deleted ",
   "\t      file first char and password info. ",
   NULL
};


char *debug_h[] = {
"\n\n'h'\tDisplays current memory status:",
"\n\tHeap: near heap size, largest block.",
"\tAlloc/Free calls: huge,far,near/huge,far,near.",
"\tUsed/Free blocks: far/near.",
"\nNote:\tThe number of blocks may differ from the",
"\tnumber of calls due to the C libary's internal",
"\tmemory management which DISKED is unable to track.",
NULL
};
